/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.ConfTotemVentaRapidaDAO;
import com.rjconsultores.ventaboletos.entidad.ConfTotemVentaRapida;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.service.ConfTotemVentaRapidaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

/**
 *
 * @author wallace
 */
@Service("confTotemVentaRapidaService")
public class ConfTotemVentaRapidaServiceImpl implements ConfTotemVentaRapidaService {

	@Autowired
	private ConfTotemVentaRapidaDAO confTotemVentaRapidaDAO;

	@Override
	public List<ConfTotemVentaRapida> obtenerTodos() {
		return confTotemVentaRapidaDAO.obtenerTodos();
	}

	@Override
	public ConfTotemVentaRapida obtenerID(Integer id) {
		return confTotemVentaRapidaDAO.obtenerID(id);
	}

	@Transactional
	@Override
	public ConfTotemVentaRapida suscribir(ConfTotemVentaRapida entidad) {
		
		entidad.setActivo(Boolean.TRUE);
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());

		return confTotemVentaRapidaDAO.suscribir(entidad);
	}

	@Transactional
	@Override
	public ConfTotemVentaRapida actualizacion(ConfTotemVentaRapida entidad) {
		
		
		entidad.setActivo(Boolean.TRUE);
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		return confTotemVentaRapidaDAO.actualizacion(entidad);
	}

	@Transactional
	@Override
	public void borrar(ConfTotemVentaRapida entidad) {
		
		entidad.setActivo(Boolean.FALSE);
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		
		confTotemVentaRapidaDAO.actualizacion(entidad);

	}

	@Override
	public ConfTotemVentaRapida buscarOrigemDestino(Parada origem, Parada destino) {
		return confTotemVentaRapidaDAO.buscarOrigemDestino(origem, destino);
	}

	@Override
	public List<ConfTotemVentaRapida> buscarOrigem(Parada origem) {
		return confTotemVentaRapidaDAO.buscarOrigem(origem);
	}

	@Override
	@Transactional
	public void apagarPorOrigem(Parada paradaOrigem) {	
		
		for (ConfTotemVentaRapida confTotemVentaRapida : confTotemVentaRapidaDAO.buscarOrigem(paradaOrigem)) {
			confTotemVentaRapida.setActivo(Boolean.FALSE);
			confTotemVentaRapida.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
			confTotemVentaRapida.setFecmodif(Calendar.getInstance().getTime());
			confTotemVentaRapidaDAO.actualizacion(confTotemVentaRapida);
		}

	}

}
